"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
exports.__esModule = true;
var db_1 = require("../db");
var sequelize_1 = require("sequelize");
var Account = db_1["default"].define('account', {
    key: {
        type: sequelize_1.DataTypes.STRING,
        primaryKey: true
    },
    format: sequelize_1.DataTypes.STRING,
    about: sequelize_1.DataTypes.TEXT
});
Account.findAllWithIncludes = function () {
    return this.findAll({
        include: [
            { association: 'validated', attributes: ['id', 'timestamp'] },
            { model: db_1["default"].models.member, attributes: ['handle'] },
        ]
    });
};
Account.findByIdWithIncludes = function (id) {
    return this.findByPk(id, {
        include: [
            { association: 'validated', attributes: ['id', 'timestamp'] },
            { model: db_1["default"].models.member, attributes: ['handle'] },
        ]
    });
};
Account.findWithIncludes = function (args) {
    return this.findAll(__assign(__assign({}, args), { include: [
            { association: 'validated', attributes: ['id', 'timestamp'] },
            { model: db_1["default"].models.member, attributes: ['handle'] },
        ] }));
};
exports["default"] = Account;
