"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
exports.__esModule = true;
var db_1 = require("../db");
var sequelize_1 = require("sequelize");
var Council = db_1["default"].define('council', {
    round: {
        type: sequelize_1.DataTypes.INTEGER,
        primaryKey: true
    },
    start: sequelize_1.DataTypes.INTEGER,
    startDate: sequelize_1.DataTypes.DATE,
    end: sequelize_1.DataTypes.INTEGER,
    endDate: sequelize_1.DataTypes.DATE
});
Council.findAllWithIncludes = function () {
    return this.findAll({
        include: [
            {
                model: db_1["default"].models.consul,
                include: [
                    { model: db_1["default"].models.member, attributes: ['handle'] },
                    {
                        association: 'votes',
                        include: [{ model: db_1["default"].models.proposal, attributes: ['title'] }]
                    },
                    {
                        association: 'voters',
                        include: [{ model: db_1["default"].models.member, attributes: ['handle'] }]
                    },
                ]
            },
        ]
    });
};
Council.findByIdWithIncludes = function (id, args) {
    return this.findByPk(id, __assign(__assign({}, args), { include: [
            {
                model: db_1["default"].models.consul,
                include: [
                    { model: db_1["default"].models.member, attributes: ['handle'] },
                    {
                        association: 'votes',
                        include: [{ model: db_1["default"].models.proposal, attributes: ['title'] }]
                    },
                    {
                        association: 'voters',
                        include: [{ model: db_1["default"].models.member, attributes: ['handle'] }]
                    },
                ]
            },
        ] }));
};
Council.findWithIncludes = function (args) {
    return this.findAll(__assign(__assign({}, args), { include: [
            {
                model: db_1["default"].models.consul,
                include: [
                    { model: db_1["default"].models.member, attributes: ['handle'] },
                    {
                        association: 'votes',
                        include: [{ model: db_1["default"].models.proposal, attributes: ['title'] }]
                    },
                    {
                        association: 'voters',
                        include: [{ model: db_1["default"].models.member, attributes: ['handle'] }]
                    },
                ]
            },
        ] }));
};
exports["default"] = Council;
