"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
exports.__esModule = true;
var db_1 = require("../db");
var sequelize_1 = require("sequelize");
var Event = db_1["default"].define('event', {
    section: sequelize_1.DataTypes.STRING,
    method: sequelize_1.DataTypes.STRING,
    data: sequelize_1.DataTypes.TEXT
});
Event.findAllWithIncludes = function () {
    return this.findAll({
        include: [
            { model: db_1["default"].models.block, include: [{ association: 'validator' }] },
        ]
    });
};
Event.findByIdWithIncludes = function (id, args) {
    return this.findByPk(id, __assign(__assign({}, args), { include: [
            { model: db_1["default"].models.block, include: [{ association: 'validator' }] },
        ] }));
};
Event.findWithIncludes = function (args) {
    return this.findAll(__assign(__assign({}, args), { include: [
            { model: db_1["default"].models.block, include: [{ association: 'validator' }] },
        ] }));
};
exports["default"] = Event;
