"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
exports.__esModule = true;
var db_1 = require("../db");
var sequelize_1 = require("sequelize");
var Post = db_1["default"].define('post', {
    id: {
        type: sequelize_1.DataTypes.INTEGER,
        primaryKey: true
    },
    text: sequelize_1.DataTypes.TEXT,
    createdAt: sequelize_1.DataTypes.INTEGER
});
Post.findAllWithIncludes = function () {
    return this.findAll({
        include: [
            { model: db_1["default"].models.thread, include: [{ model: db_1["default"].models.category }] },
            { association: 'author' },
            { association: 'moderator' },
        ]
    });
};
Post.findByIdWithIncludes = function (id, args) {
    return this.findByPk(id, __assign(__assign({}, args), { include: [
            { model: db_1["default"].models.thread, include: [{ model: db_1["default"].models.category }] },
            { association: 'moderator' },
        ] }));
};
Post.findWithIncludes = function (args) {
    return this.findAll(__assign(__assign({}, args), { include: [
            { model: db_1["default"].models.thread, include: [{ model: db_1["default"].models.category }] },
            { model: db_1["default"].models.thread },
            { association: 'moderator' },
        ] }));
};
exports["default"] = Post;
