"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.closeOpening = exports.newOpening = exports.provider = exports.formatProposalMessage = exports.heartbeat = exports.threads = exports.posts = exports.categories = exports.channels = void 0;
var util_1 = require("./util");
var getters_1 = require("./getters");
var domain = require("../../config").domain;
var sleep = function (ms) { return new Promise(function (resolve) { return setTimeout(resolve, ms); }); };
// query API repeatedly to ensure a result
var query = function (test, cb) { return __awaiter(void 0, void 0, void 0, function () {
    var result, i;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, cb()];
            case 1:
                result = _a.sent();
                i = 0;
                _a.label = 2;
            case 2:
                if (!(i < 10)) return [3 /*break*/, 6];
                if (result[test] !== "")
                    return [2 /*return*/, result];
                return [4 /*yield*/, cb()];
            case 3:
                result = _a.sent();
                return [4 /*yield*/, sleep(5000)];
            case 4:
                _a.sent();
                _a.label = 5;
            case 5:
                i++;
                return [3 /*break*/, 2];
            case 6: return [2 /*return*/];
        }
    });
}); };
// announce latest channels
exports.channels = function (api, channels, sendMessage) { return __awaiter(void 0, void 0, void 0, function () {
    var last, current, messages, _loop_1, id;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                last = channels[0], current = channels[1];
                messages = [];
                _loop_1 = function (id) {
                    var channel, member, _a;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0: return [4 /*yield*/, query("title", function () {
                                    return api.query.contentWorkingGroup.channelById(id);
                                })];
                            case 1:
                                channel = _b.sent();
                                member = { id: channel.owner, handle: "", url: "" };
                                _a = member;
                                return [4 /*yield*/, getters_1.memberHandle(api, member.id.toJSON())];
                            case 2:
                                _a.handle = _b.sent();
                                member.url = domain + "/#/members/" + member.handle;
                                messages.push("<b>Channel <a href=\"" + domain + "/#//media/channels/" + id + "\">" + channel.title + "</a> by <a href=\"" + member.url + "\">" + member.handle + " (" + member.id + ")</a></b>");
                                return [2 /*return*/];
                        }
                    });
                };
                id = +last + 1;
                _a.label = 1;
            case 1:
                if (!(id <= current)) return [3 /*break*/, 4];
                return [5 /*yield**/, _loop_1(id)];
            case 2:
                _a.sent();
                _a.label = 3;
            case 3:
                id++;
                return [3 /*break*/, 1];
            case 4:
                sendMessage(messages.join("\r\n\r\n"));
                return [2 /*return*/, current];
        }
    });
}); };
// forum
// announce latest categories
exports.categories = function (api, category, sendMessage) { return __awaiter(void 0, void 0, void 0, function () {
    var messages, _loop_2, id;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                messages = [];
                _loop_2 = function (id) {
                    var cat, msg;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, query("title", function () { return getters_1.categoryById(api, id); })];
                            case 1:
                                cat = _a.sent();
                                msg = "Category " + id + ": <b><a href=\"" + domain + "/#/forum/categories/" + id + "\">" + cat.title + "</a></b>";
                                messages.push(msg);
                                return [2 /*return*/];
                        }
                    });
                };
                id = +category[0] + 1;
                _a.label = 1;
            case 1:
                if (!(id <= category[1])) return [3 /*break*/, 4];
                return [5 /*yield**/, _loop_2(id)];
            case 2:
                _a.sent();
                _a.label = 3;
            case 3:
                id++;
                return [3 /*break*/, 1];
            case 4:
                sendMessage(messages.join("\r\n\r\n"));
                return [2 /*return*/, category[1]];
        }
    });
}); };
// announce latest posts
exports.posts = function (api, posts, sendMessage) { return __awaiter(void 0, void 0, void 0, function () {
    var last, current, messages, _loop_3, id;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                last = posts[0], current = posts[1];
                messages = [];
                _loop_3 = function (id) {
                    var post, replyId, message, excerpt, threadId, thread, threadTitle, category, handle, msg;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, query("current_text", function () {
                                    return api.query.forum.postById(id);
                                })];
                            case 1:
                                post = _a.sent();
                                replyId = +post.nr_in_thread;
                                message = post.current_text;
                                excerpt = message.substring(0, 100);
                                threadId = +post.thread_id;
                                return [4 /*yield*/, query("title", function () {
                                        return api.query.forum.threadById(threadId);
                                    })];
                            case 2:
                                thread = _a.sent();
                                threadTitle = thread.title;
                                return [4 /*yield*/, query("title", function () {
                                        return getters_1.categoryById(api, +thread.category_id);
                                    })];
                            case 3:
                                category = _a.sent();
                                return [4 /*yield*/, getters_1.memberHandleByAccount(api, post.author_id.toJSON())];
                            case 4:
                                handle = _a.sent();
                                msg = "<b><a href=\"" + domain + "/#/members/" + handle + "\">" + handle + "</a> posted <a href=\"" + domain + "/#/forum/threads/" + threadId + "?replyIdx=" + replyId + "\">" + threadTitle + "</a> in <a href=\"" + domain + "/#/forum/categories/" + category.id + "\">" + category.title + "</a>:</b>\n\r<i>" + excerpt + "</i> <a href=\"" + domain + "/#/forum/threads/" + threadId + "?replyIdx=" + replyId + "\">more</a>";
                                messages.push(msg);
                                return [2 /*return*/];
                        }
                    });
                };
                id = +last + 1;
                _a.label = 1;
            case 1:
                if (!(id <= current)) return [3 /*break*/, 4];
                return [5 /*yield**/, _loop_3(id)];
            case 2:
                _a.sent();
                _a.label = 3;
            case 3:
                id++;
                return [3 /*break*/, 1];
            case 4:
                sendMessage(messages.join("\r\n\r\n"));
                return [2 /*return*/, current];
        }
    });
}); };
// announce latest threads
exports.threads = function (api, threads, sendMessage) { return __awaiter(void 0, void 0, void 0, function () {
    var last, current, messages, _loop_4, id;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                last = threads[0], current = threads[1];
                messages = [];
                _loop_4 = function (id) {
                    var thread, title, author_id, handle, category, msg;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, query("title", function () {
                                    return api.query.forum.threadById(id);
                                })];
                            case 1:
                                thread = _a.sent();
                                title = thread.title, author_id = thread.author_id;
                                return [4 /*yield*/, getters_1.memberHandleByAccount(api, author_id.toJSON())];
                            case 2:
                                handle = _a.sent();
                                return [4 /*yield*/, query("title", function () {
                                        return getters_1.categoryById(api, +thread.category_id);
                                    })];
                            case 3:
                                category = _a.sent();
                                msg = "Thread " + id + ": <a href=\"" + domain + "/#/forum/threads/" + id + "\">\"" + title + "\"</a> by <a href=\"" + domain + "/#/members/" + handle + "\">" + handle + "</a> in category \"<a href=\"" + domain + "/#/forum/categories/" + category.id + "\">" + category.title + "</a>\" ";
                                messages.push(msg);
                                return [2 /*return*/];
                        }
                    });
                };
                id = +last + 1;
                _a.label = 1;
            case 1:
                if (!(id <= current)) return [3 /*break*/, 4];
                return [5 /*yield**/, _loop_4(id)];
            case 2:
                _a.sent();
                _a.label = 3;
            case 3:
                id++;
                return [3 /*break*/, 1];
            case 4:
                sendMessage(messages.join("\r\n\r\n"));
                return [2 /*return*/, current];
        }
    });
}); };
// heartbeat
var getAverage = function (array) {
    return array.reduce(function (a, b) { return a + b; }, 0) / array.length;
};
exports.heartbeat = function (api, summary, timePassed, accountId, sendMessage) { return __awaiter(void 0, void 0, void 0, function () {
    var blocks, nominators, validators, avgDuration, era, totalStake, stakers, stakerCount, avgStake;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                blocks = summary.blocks, nominators = summary.nominators, validators = summary.validators;
                avgDuration = blocks.reduce(function (a, b) { return a + b.duration; }, 0) / blocks.length;
                return [4 /*yield*/, api.query.staking.currentEra()];
            case 1:
                era = _a.sent();
                return [4 /*yield*/, api.query.staking.erasTotalStake(parseInt(era))];
            case 2:
                totalStake = _a.sent();
                return [4 /*yield*/, api.query.staking.erasStakers(parseInt(era), accountId)];
            case 3:
                stakers = _a.sent();
                stakerCount = stakers.others.length;
                avgStake = parseInt(totalStake.toString()) / stakerCount;
                console.log("\n  Blocks produced during " + timePassed + "h in era " + era + ": " + blocks.length + "\n  Average blocktime: " + Math.floor(avgDuration) / 1000 + " s\n  Average stake: " + avgStake / 1000000 + " M JOY (" + stakerCount + " stakers)\n  Average number of nominators: " + getAverage(nominators) + "\n  Average number of validators: " + getAverage(validators));
                return [2 /*return*/];
        }
    });
}); };
exports.formatProposalMessage = function (data) {
    var id = data[0], title = data[1], type = data[2], stage = data[3], result = data[4], handle = data[5];
    return "<b>Type</b>: " + type + "\r\n<b>Proposer</b>: <a href=\"" + domain + "/#/members/" + handle + "\">" + handle + "</a>\r\n<b>Title</b>: <a href=\"" + domain + "/#/proposals/" + id + "\">" + title + "</a>\r\n<b>Stage</b>: " + stage + "\r\n<b>Result</b>: " + result;
};
// providers
exports.provider = function (id, address, status, sendMessage) {
    var msg = "[" + util_1.formatTime() + "] Storage Provider " + id + " (" + address + ") is " + status;
    sendMessage(msg);
};
exports.newOpening = function (id, sendMessage) {
    var msg = "New opening: <b><a href=\"" + domain + "/#/working-groups/opportunities/curators/" + id + "\">Storage Provider " + id + "</a></b>";
    sendMessage(msg);
};
exports.closeOpening = function (id, handle, sendMessage) {
    var msg = "<a href=\"" + domain + "/#/members/" + handle + "\">" + handle + "</a> was choosen as <b><a href=\"" + domain + "/#/working-groups/opportunities/curators/" + id + "\">Storage Provider " + id + "</a></b>";
    sendMessage(msg);
};
