"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.nextWorkerId = exports.nextOpeningId = exports.providerStatus = exports.proposalDetail = exports.activeProposals = exports.pendingProposals = exports.activeProposalCount = exports.proposalCount = exports.currentCategoryId = exports.currentThreadId = exports.currentPostId = exports.categoryById = exports.memberHandleByAccount = exports.memberIdByAccount = exports.memberHandle = exports.membership = exports.currentChannelId = void 0;
var announcements_1 = require("./announcements");
var node_fetch_1 = require("node-fetch");
// channel
exports.currentChannelId = function (api) { return __awaiter(void 0, void 0, void 0, function () {
    var id;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, api.query.contentWorkingGroup.nextChannelId()];
            case 1:
                id = _a.sent();
                return [2 /*return*/, Number(id) - 1];
        }
    });
}); };
// members
exports.membership = function (api, id) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, api.query.members.membershipById(id)];
            case 1: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.memberHandle = function (api, id) { return __awaiter(void 0, void 0, void 0, function () {
    var member;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, exports.membership(api, id)];
            case 1:
                member = _a.sent();
                return [2 /*return*/, member.handle.toJSON()];
        }
    });
}); };
exports.memberIdByAccount = function (api, account) { return __awaiter(void 0, void 0, void 0, function () {
    var ids;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, api.query.members.memberIdsByRootAccountId(account)];
            case 1:
                ids = _a.sent();
                return [2 /*return*/, ids.length ? ids[0] : 0];
        }
    });
}); };
exports.memberHandleByAccount = function (api, account) { return __awaiter(void 0, void 0, void 0, function () {
    var id, handle;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, api.query.members.memberIdsByRootAccountId(account)];
            case 1:
                id = _a.sent();
                return [4 /*yield*/, exports.memberHandle(api, id)];
            case 2:
                handle = _a.sent();
                return [2 /*return*/, handle === 'joystream_storage_member' ? 'joystream' : handle];
        }
    });
}); };
// forum
exports.categoryById = function (api, id) { return __awaiter(void 0, void 0, void 0, function () {
    var category;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, api.query.forum.categoryById(id)];
            case 1:
                category = _a.sent();
                return [2 /*return*/, category];
        }
    });
}); };
exports.currentPostId = function (api) { return __awaiter(void 0, void 0, void 0, function () {
    var postId;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, api.query.forum.nextPostId()];
            case 1:
                postId = _a.sent();
                return [2 /*return*/, Number(postId) - 1];
        }
    });
}); };
exports.currentThreadId = function (api) { return __awaiter(void 0, void 0, void 0, function () {
    var threadId;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, api.query.forum.nextThreadId()];
            case 1:
                threadId = _a.sent();
                return [2 /*return*/, Number(threadId) - 1];
        }
    });
}); };
exports.currentCategoryId = function (api) { return __awaiter(void 0, void 0, void 0, function () {
    var categoryId;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, api.query.forum.nextCategoryId()];
            case 1:
                categoryId = _a.sent();
                return [2 /*return*/, Number(categoryId) - 1];
        }
    });
}); };
// proposals
exports.proposalCount = function (api) { return __awaiter(void 0, void 0, void 0, function () {
    var proposalCount;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, api.query.proposalsEngine.proposalCount()];
            case 1:
                proposalCount = _a.sent();
                return [2 /*return*/, proposalCount.toJSON() || 0];
        }
    });
}); };
exports.activeProposalCount = function (api) { return __awaiter(void 0, void 0, void 0, function () {
    var proposalCount;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, api.query.proposalsEngine.activeProposalCount()];
            case 1:
                proposalCount = _a.sent();
                return [2 /*return*/, proposalCount || 0];
        }
    });
}); };
exports.pendingProposals = function (api) { return __awaiter(void 0, void 0, void 0, function () {
    var pending, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                _b = (_a = api.query.proposalsEngine).pendingExecutionProposalIds;
                return [4 /*yield*/, exports.activeProposalCount(api)];
            case 1: return [4 /*yield*/, _b.apply(_a, [_c.sent()])
                //const pending: ProposalArray = pendingProposals.toJSON();
            ];
            case 2:
                pending = _c.sent();
                //const pending: ProposalArray = pendingProposals.toJSON();
                if (pending.length)
                    console.debug('pending proposals', pending);
                return [2 /*return*/, pending];
        }
    });
}); };
exports.activeProposals = function (api) { return __awaiter(void 0, void 0, void 0, function () {
    var active, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                _b = (_a = api.query.proposalsEngine).activeProposalIds;
                return [4 /*yield*/, exports.activeProposalCount(api)];
            case 1: return [4 /*yield*/, _b.apply(_a, [_c.sent()])
                //const active: ProposalArray = result.toJSON();
            ];
            case 2:
                active = _c.sent();
                //const active: ProposalArray = result.toJSON();
                if (active.length)
                    console.debug('active proposals', active);
                return [2 /*return*/, active];
        }
    });
}); };
var getProposalType = function (api, id) { return __awaiter(void 0, void 0, void 0, function () {
    var details, type;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, api.query.proposalsCodex.proposalDetailsByProposalId(id)];
            case 1:
                details = _a.sent();
                type = Object.getOwnPropertyNames(details.toJSON())[0];
                return [2 /*return*/, type];
        }
    });
}); };
exports.proposalDetail = function (api, id) { return __awaiter(void 0, void 0, void 0, function () {
    var proposal, status, stage, _a, finalizedAt, proposalStatus, result, exec, description, parameters, proposerId, votingResults, author, title, type, args, message, createdAt;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0: return [4 /*yield*/, api.query.proposalsEngine.proposals(id)];
            case 1:
                proposal = _b.sent();
                status = proposal.status;
                stage = status.isActive ? 'Active' : 'Finalized';
                _a = status["as" + stage], finalizedAt = _a.finalizedAt, proposalStatus = _a.proposalStatus;
                result = proposalStatus
                    ? (proposalStatus.isApproved && 'Approved') ||
                        (proposalStatus.isCanceled && 'Canceled') ||
                        (proposalStatus.isExpired && 'Expired') ||
                        (proposalStatus.isRejected && 'Rejected') ||
                        (proposalStatus.isSlashed && 'Slashed') ||
                        (proposalStatus.isVetoed && 'Vetoed')
                    : 'Pending';
                exec = proposalStatus ? proposalStatus['Approved'] : null;
                description = proposal.description, parameters = proposal.parameters, proposerId = proposal.proposerId, votingResults = proposal.votingResults;
                return [4 /*yield*/, exports.memberHandle(api, proposerId)];
            case 2:
                author = _b.sent();
                title = proposal.title.toString();
                return [4 /*yield*/, getProposalType(api, id)];
            case 3:
                type = _b.sent();
                args = [String(id), title, type, stage, result, author];
                message = announcements_1.formatProposalMessage(args);
                createdAt = Number(proposal.createdAt);
                return [2 /*return*/, {
                        id: id,
                        title: title,
                        createdAt: createdAt,
                        finalizedAt: finalizedAt,
                        parameters: JSON.stringify(parameters),
                        message: message,
                        stage: stage,
                        result: result,
                        exec: exec,
                        description: description.toHuman(),
                        votes: votingResults,
                        type: type,
                        author: author,
                        authorId: Number(proposerId)
                    }];
        }
    });
}); };
// storage providers
exports.providerStatus = function (domain) { return __awaiter(void 0, void 0, void 0, function () {
    var res, e_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, node_fetch_1["default"]("https://" + domain + ":5001/api/v0/version")];
            case 1:
                res = _a.sent();
                return [2 /*return*/, res.status >= 400 ? false : true];
            case 2:
                e_1 = _a.sent();
                return [2 /*return*/, false];
            case 3: return [2 /*return*/];
        }
    });
}); };
exports.nextOpeningId = function (api) { return __awaiter(void 0, void 0, void 0, function () {
    var id;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, api.query.storageWorkingGroup.nextOpeningId()];
            case 1:
                id = _a.sent();
                return [2 /*return*/, id.toJSON()];
        }
    });
}); };
exports.nextWorkerId = function (api) { return __awaiter(void 0, void 0, void 0, function () {
    var id;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, api.query.storageWorkingGroup.nextWorkerId()];
            case 1:
                id = _a.sent();
                return [2 /*return*/, id.toJSON()];
        }
    });
}); };
